Dallas Semiconductor 1-Wire API 1.00 Alpha: Class OWFile

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.dalsemi.onewire.utils
Class OWFile

    java.lang.Object
      |
      +--com.dalsemi.onewire.utils.OWFile

public class OWFile
extends Object

An abstract representation of file and directory pathnames on 1-Wire devices.

User interfaces and operating systems use system-dependent pathname strings to name files and directories. This class presents an abstract, system-independent view of hierarchical pathnames. An abstract pathname has two components:

1. An optional system-dependent prefix string,
   such as a disk-drive specifier, `"/"` for the UNIX root directory, or `"\\"` for a Win32 UNC pathname, and
2. A sequence of zero or more string names.

Each name in an abstract pathname except for the last denotes a directory; the last name may denote either a directory or a file. The empty abstract pathname has no prefix and an empty name sequence.

The conversion of a pathname string to or from an abstract pathname is inherently system-dependent. When an abstract pathname is converted into a pathname string, each name is separated from the next by a single copy of the default separator character. The default name-separator character is defined by the system property `OWFile.separator`, and is made available in the public static fields ``separator`` and ``separatorChar`` of this class. When a pathname string is converted into an abstract pathname, the names within it may be separated by the default name-separator character or by any other name-separator character that is supported by the underlying system.

A pathname, whether abstract or in string form, may be either absolute or relative. An absolute pathname is complete in that no other information is required in order to locate the file that it denotes. A relative pathname, in contrast, must be interpreted in terms of information taken from some other pathname. By default the classes in the `java.io` package always resolve relative pathnames against the current user directory. This directory is named by the system property `user.dir`, and is typically the directory in which the Java virtual machine was invoked. The pathname provided to this OWFile however is always absolute.

The prefix concept is used to handle root directories on UNIX platforms, and drive specifiers, root directories and UNC pathnames on Win32 platforms, as follows:

- For 1-Wire the Filesystem , the prefix of an absolute pathname is always `"/"`. The abstract pathname denoting the root directory has the prefix `"/"` and an empty name sequence.

Instances of the `OWFile` class are immutable; that is, once created, the abstract pathname represented by a `OWFile` object will never change.

### What is Different on the 1-Wire Filesystem

The methods in the class are the same as in the java.io.File version 1.2 with the following exceptions

Methods provided but of limited functionallity

- public long lastModified() - always returns 0
- public boolean isAbsolute() - always true
- public boolean setLastModified(long time) - does nothing
- public boolean setReadOnly() - only for files
- public boolean isHidden() - only could be true for directories

Methods not provided or supported:

- public void deleteOnExit()
- public String[] list(FilenameFilter filter)
- public File[] listFiles(FilenameFilter filter)
- public File[] listFiles(FileFilter filter)
- public static File createTempFile(String prefix, String suffix, File directory)
- public static File createTempFile(String prefix, String suffix)
- public URL toURL()

Extra Methods (not usually in 1.2 java.io.File)

- public OWFileDescriptor getFD()
- public void close()
- public OneWireContainer getOneWireContainer()
- public void format()
- public int getFreeMemory()
- public int[] getPageList()
- public PagedMemoryBank getMemoryBankForPage(int)
- public int getLocalPage(int)

File and directory name limitations

- File/directory names limited to 4 characters not including extension
- File/directory names are not case sensitive and will be automatically changed to all-CAPS
- Only files can have extensions
- Extensions are numberical in the range 0 to 125
- Extensions 100 to 125 are special purpose and not yet implemented or allowed
- Files can have the read-only attribute
- Directories can have the hidden attribute
- It is recommended to limit directory depth to 10 levels to accomodate legacy implementations

### Tips

- Writes will not be flushed to the 1-Wire device Filesystem until the `OWFile` instance is closed with the `close()` method or the `sync()` method from the OWFileDescriptor
- The `sync()` method for flushing the changes to the Filesystem is preferred since it can be called multiple times if there is a connection problem
- New 1-Wire devices Filesystem must first be formatted with the `format()` method in order for files or directories to be added or changed.
- Multiple 1-Wire devices can be linked into a common Filesystem by using the constructor that accepts an array of 1-Wire devices. The first device in the list is the 'root' device and the rest will be designated 'satelite's. Once the `format()` method is used to link these devices then only the 'root' need be used in future constuctors of this class or the 1-Wire file stream classes.
- Only rewrittable 1-Wire memory devices can be used in multi-device file systems. EPROM and write-once devices can only be used in single device file systems.
- 1-Wire devices have a limited amount of space. Use the `getFreeMemory()` method to get an estimate of free memory available.
- Call the `close()` method to release system resources allocated when done with the `OWFile` instance

### Usage

  #### Example 1

  Format the Filesystem of the 1-Wire device 'owd':

         // create a 1-Wire file at root
         OWFile owfile = new OWFile(owd, "");

         // format Filesystem
         owfile.format();

         // get 1-Wire File descriptor to flush to device
         OWFileDescriptor owfd = owfile.getFD();
         // loop until sync is successful
         do
         {
            try
            {
               owfd.sync();
               done = true;
            }
            catch (SyncFailedException e)
            {
               // do something
               ...
               done = false;
            }
         }
         while (!done)

         // close the 1-Wire file to release system resources
         owfile.close();

  #### Example 2

  Make a multi-level directory structure on the 1-Wire device 'owd':

         OWFile owfile = new OWFile(owd, "/doc/text/temp");

         // make the directories
         if (owfile.mkdirs())
            System.out.println("Success!");
         else
            System.out.println("Out of memory or invalid file/directory");

         // get 1-Wire File descriptor to flush to device
         ...

### 1-Wire File Structure Format

  http://pdfserv.maxim-ic.com/arpdf/AppNotes/app114.pdf

Version:
  0.01, 1 June 2001
See Also:
  `OWFileDescriptor`, `OWFileInputStream`, `OWFileOutputStream`

Field Summary
`static String` | `pathSeparator` Field pathSeparator
`static char` | `pathSeparatorChar` Field pathSeparatorChar
`static String` | `separator` Field separator
`static char` | `separatorChar` Field separatorChar

Constructor Summary
`OWFile(OneWireContainer[] owd, String pathname)` Creates a new `OWFile` instance by converting the given pathname string into an abstract pathname.
`OWFile(OneWireContainer owd, String pathname)` Creates a new `OWFile` instance by converting the given pathname string into an abstract pathname.
`OWFile(OneWireContainer owd, String parent, String child)` Creates a new `OWFile` instance from a parent pathname string and a child pathname string.
`OWFile(OWFile parent, String child)` Creates a new `OWFile` instance from a parent abstract pathname and a child pathname string.

Method Summary
`boolean` | `canRead()` Tests whether the application can read the file denoted by this abstract pathname.
`boolean` | `canWrite()` Tests whether the application can modify to the file denoted by this abstract pathname.
`void` | `close()` Closes this file and releases any system resources associated with this stream.
`int` | `compareTo(Object o)` Compares this abstract pathname to another object.
`int` | `compareTo(OWFile pathname)` Compares two abstract pathnames lexicographically.
`boolean` | `createNewFile()` Atomically creates a new, empty file named by this abstract pathname if and only if a file with this name does not yet exist.
`boolean` | `delete()` Deletes the file or directory denoted by this abstract pathname.
`boolean` | `equals(Object obj)` Tests this abstract pathname for equality with the given object.
`boolean` | `exists()` Tests whether the file denoted by this abstract pathname exists.
`void` | `format()` Format the Filesystem on the 1-Wire device provided in the constructor.
`OWFile` | `getAbsoluteFile()` Returns the absolute form of this abstract pathname.
`String` | `getAbsolutePath()` Returns the absolute pathname string of this abstract pathname.
`OWFile` | `getCanonicalFile()` Returns the canonical form of this abstract pathname.
`String` | `getCanonicalPath()` Returns the canonical pathname string of this abstract pathname.
`OWFileDescriptor` | `getFD()` Returns the `OWFileDescriptor` object that represents the connection to the actual file in the Filesystem being used by this `OWFileInputStream`.
`int` | `getFreeMemory()` Gets the number of bytes available on this device for file and directory information.
`int` | `getLocalPage(int page)` Get's the local page number on the memory bank object for the specified page.
`PagedMemoryBank` | `getMemoryBankForPage(int page)` Get's the memory bank object for the specified page.
`String` | `getName()` Returns the name of the file or directory denoted by this abstract pathname.
`OneWireContainer` | `getOneWireContainer()` Gets the OneWireContainer that this File resides on.
`OneWireContainer[]` | `getOneWireContainers()` Gets the OneWireContainer(s) that this File resides on.
`int[]` | `getPageList()` Get's an array of integers that represents the page list of the file or directory represented by this OWFile.
`String` | `getParent()` Returns the pathname string of this abstract pathname's parent, or `null` if this pathname does not name a parent directory.
`OWFile` | `getParentFile()` Returns the abstract pathname of this abstract pathname's parent, or `null` if this pathname does not name a parent directory.
`String` | `getPath()` Converts this abstract pathname into a pathname string.
`int` | `hashCode()` Computes a hash code for this abstract pathname.
`boolean` | `isAbsolute()` Tests whether this abstract pathname is absolute.
`boolean` | `isDirectory()` Tests whether the file denoted by this abstract pathname is a directory.
`boolean` | `isFile()` Tests whether the file denoted by this abstract pathname is a normal file.
`boolean` | `isHidden()` Tests whether the file named by this abstract pathname is a hidden file.
`long` | `lastModified()` Returns the time that the file denoted by this abstract pathname was last modified.
`long` | `length()` Returns the length of the file denoted by this abstract pathname.
`String[]` | `list()` Returns an array of strings naming the files and directories in the directory denoted by this abstract pathname.
`OWFile[]` | `listFiles()` Returns an array of abstract pathnames denoting the files in the directory denoted by this abstract pathname.
`static OWFile[]` | `listRoots(OneWireContainer owc)` List the available filesystem roots.
`boolean` | `mkdir()` Creates the directory named by this abstract pathname.
`boolean` | `mkdirs()` Creates the directory named by this abstract pathname, including any necessary but nonexistent parent directories.
`boolean` | `renameTo(OWFile dest)` Renames the file denoted by this abstract pathname.
`boolean` | `setLastModified(long time)` Sets the last-modified time of the file or directory named by this abstract pathname.
`boolean` | `setReadOnly()` Marks the file or directory named by this abstract pathname so that only read operations are allowed.
`String` | `toString()` Returns the pathname string of this abstract pathname.

Methods inherited from class java.lang.Object
`getClass, notify, notifyAll, wait, wait, wait`

Field Detail

### separator

    public static final String separator

  Field separator

### separatorChar

    public static final char separatorChar

  Field separatorChar

### pathSeparator

    public static final String pathSeparator

  Field pathSeparator

### pathSeparatorChar

    public static final char pathSeparatorChar

  Field pathSeparatorChar

Constructor Detail

### OWFile

    public OWFile(OneWireContainer owd,
                  String pathname)

  Creates a new `OWFile` instance by converting the given pathname string into an abstract pathname. If the given string is the empty string, then the result is the empty abstract pathname.
  Parameters:
    `owd` - OneWireContainer that this Filesystem resides on
    `pathname` - A pathname string
  Throws:
    `NullPointerException` - If the `pathname` argument is `null`

### OWFile

    public OWFile(OneWireContainer[] owd,
                  String pathname)

  Creates a new `OWFile` instance by converting the given pathname string into an abstract pathname. If the given string is the empty string, then the result is the empty abstract pathname.
  Parameters:
    `owd` - ordered array of OneWireContainers that this Filesystem resides on
    `pathname` - A pathname string
  Throws:
    `NullPointerException` - If the `pathname` argument is `null` Change the OWFileDescriptor to accept only an array of containers Change the local ref to be an array Create a single array in constructors with single passed owc

### OWFile

    public OWFile(OneWireContainer owd,
                  String parent,
                  String child)

  Creates a new `OWFile` instance from a parent pathname string and a child pathname string.

  If `parent` is `null` then the new `OWFile` instance is created as if by invoking the single-argument `OWFile` constructor on the given `child` pathname string.

  Otherwise the `parent` pathname string is taken to denote a directory, and the `child` pathname string is taken to denote either a directory or a file. If the `child` pathname string is absolute then it is converted into a relative pathname in a system-dependent way. If `parent` is the empty string then the new `OWFile` instance is created by converting `child` into an abstract pathname and resolving the result against a system-dependent default directory. Otherwise each pathname string is converted into an abstract pathname and the child abstract pathname is resolved against the parent.

  Parameters:
    `owd` - OneWireContainer that this Filesystem resides on
    `parent` - The parent pathname string
    `child` - The child pathname string
  Throws:
    `NullPointerException` - If `child` is `null`

### OWFile

    public OWFile(OWFile parent,
                  String child)

  Creates a new `OWFile` instance from a parent abstract pathname and a child pathname string.

  If `parent` is `null` then the new `OWFile` instance is created as if by invoking the single-argument `OWFile` constructor on the given `child` pathname string.

  Otherwise the `parent` abstract pathname is taken to denote a directory, and the `child` pathname string is taken to denote either a directory or a file. If the `child` pathname string is absolute then it is converted into a relative pathname in a system-dependent way. If `parent` is the empty abstract pathname then the new `OWFile` instance is created by converting `child` into an abstract pathname and resolving the result against a system-dependent default directory. Otherwise each pathname string is converted into an abstract pathname and the child abstract pathname is resolved against the parent.

  Parameters:
    `owd` - OneWireContainer that this Filesystem resides on
    `parent` - The parent abstract pathname
    `child` - The child pathname string
  Throws:
    `NullPointerException` - If `child` is `null`

Method Detail

### getName

    public String getName()

  Returns the name of the file or directory denoted by this abstract pathname. This is just the last name in the pathname's name sequence. If the pathname's name sequence is empty, then the empty string is returned.
  Returns:
    The name of the file or directory denoted by this abstract pathname, or the empty string if this pathname's name sequence is empty

### getParent

    public String getParent()

  Returns the pathname string of this abstract pathname's parent, or `null` if this pathname does not name a parent directory.

  The parent of an abstract pathname consists of the pathname's prefix, if any, and each name in the pathname's name sequence except for the last. If the name sequence is empty then the pathname does not name a parent directory.

  Returns:
    The pathname string of the parent directory named by this abstract pathname, or `null` if this pathname does not name a parent

### getParentFile

    public OWFile getParentFile()

  Returns the abstract pathname of this abstract pathname's parent, or `null` if this pathname does not name a parent directory.

  The parent of an abstract pathname consists of the pathname's prefix, if any, and each name in the pathname's name sequence except for the last. If the name sequence is empty then the pathname does not name a parent directory.

  Returns:
    The abstract pathname of the parent directory named by this abstract pathname, or `null` if this pathname does not name a parent

### getPath

    public String getPath()

  Converts this abstract pathname into a pathname string. The resulting string uses the `default name-separator character` to separate the names in the name sequence.
  Returns:
    The string form of this abstract pathname

### isAbsolute

    public boolean isAbsolute()

  Tests whether this abstract pathname is absolute. The definition of absolute pathname is system dependent. On UNIX systems, a pathname is absolute if its prefix is `"/"`. On Win32 systems, a pathname is absolute if its prefix is a drive specifier followed by `"\\"`, or if its prefix is `"\\"`.
  Returns:
    `true` if this abstract pathname is absolute, `false` otherwise

### getAbsolutePath

    public String getAbsolutePath()

  Returns the absolute pathname string of this abstract pathname.

  If this abstract pathname is already absolute, then the pathname string is simply returned as if by the ``getPath()`` method. If this abstract pathname is the empty abstract pathname then the pathname string of the current user directory, which is named by the system property `user.dir`, is returned. Otherwise this pathname is resolved in a system-dependent way. On UNIX systems, a relative pathname is made absolute by resolving it against the current user directory. On Win32 systems, a relative pathname is made absolute by resolving it against the current directory of the drive named by the pathname, if any; if not, it is resolved against the current user directory.

  Returns:
    The absolute pathname string denoting the same file or directory as this abstract pathname
  See Also:
    `File.isAbsolute()`

### getAbsoluteFile

    public OWFile getAbsoluteFile()

  Returns the absolute form of this abstract pathname. Equivalent to `new File(this.`getAbsolutePath()`())`.
  Returns:
    The absolute abstract pathname denoting the same file or directory as this abstract pathname

### getCanonicalPath

    public String getCanonicalPath()
                            throws IOException

  Returns the canonical pathname string of this abstract pathname.

  The precise definition of canonical form is system-dependent, but canonical forms are always absolute. Thus if this abstract pathname is relative it will be converted to absolute form as if by the ``getAbsoluteFile()`` method.

  Every pathname that denotes an existing file or directory has a unique canonical form. Every pathname that denotes a nonexistent file or directory also has a unique canonical form. The canonical form of the pathname of a nonexistent file or directory may be different from the canonical form of the same pathname after the file or directory is created. Similarly, the canonical form of the pathname of an existing file or directory may be different from the canonical form of the same pathname after the file or directory is deleted.

  Returns:
    The canonical pathname string denoting the same file or directory as this abstract pathname
  Throws:
    `IOException` - If an I/O error occurs, which is possible because the construction of the canonical pathname may require filesystem queries
  Since:
    JDK1.1

### getCanonicalFile

    public OWFile getCanonicalFile()
                            throws IOException

  Returns the canonical form of this abstract pathname. Equivalent to `new File(this.`getCanonicalPath()`())`.
  Returns:
    The canonical pathname string denoting the same file or directory as this abstract pathname
  Throws:
    `IOException` - If an I/O error occurs, which is possible because the construction of the canonical pathname may require filesystem queries

### canRead

    public boolean canRead()

  Tests whether the application can read the file denoted by this abstract pathname.
  Returns:
    `true` if and only if the file specified by this abstract pathname exists and can be read by the application; `false` otherwise

### canWrite

    public boolean canWrite()

  Tests whether the application can modify to the file denoted by this abstract pathname.
  Returns:
    `true` if and only if the Filesystem actually contains a file denoted by this abstract pathname and the application is allowed to write to the file; `false` otherwise.

### exists

    public boolean exists()

  Tests whether the file denoted by this abstract pathname exists.
  Returns:
    `true` if and only if the file denoted by this abstract pathname exists; `false` otherwise

### isDirectory

    public boolean isDirectory()

  Tests whether the file denoted by this abstract pathname is a directory.
  Returns:
    `true` if and only if the file denoted by this abstract pathname exists and is a directory; `false` otherwise

### isFile

    public boolean isFile()

  Tests whether the file denoted by this abstract pathname is a normal file. A file is normal if it is not a directory and, in addition, satisfies other system-dependent criteria. Any non-directory file created by a Java application is guaranteed to be a normal file.
  Returns:
    `true` if and only if the file denoted by this abstract pathname exists and is a normal file; `false` otherwise

### isHidden

    public boolean isHidden()

  Tests whether the file named by this abstract pathname is a hidden file. The exact definition of hidden is system-dependent. On UNIX systems, a file is considered to be hidden if its name begins with a period character (`'.'`). On Win32 systems, a file is considered to be hidden if it has been marked as such in the filesystem.
  Returns:
    `true` if and only if the file denoted by this abstract pathname is hidden according to the conventions of the underlying platform

### lastModified

    public long lastModified()

  Returns the time that the file denoted by this abstract pathname was last modified.
  Returns:
    A `long` value representing the time the file was last modified, measured in milliseconds since the epoch (00:00:00 GMT, January 1, 1970), or `0L` if the file does not exist or if an I/O error occurs

### length

    public long length()

  Returns the length of the file denoted by this abstract pathname.
  Returns:
    The length, in bytes, of the file denoted by this abstract pathname, or `0L` if the file does not exist

### createNewFile

    public boolean createNewFile()
                          throws IOException

  Atomically creates a new, empty file named by this abstract pathname if and only if a file with this name does not yet exist. The check for the existence of the file and the creation of the file if it does not exist are a single operation that is atomic with respect to all other filesystem activities that might affect the file.
  Returns:
    `true` if the named file does not exist and was successfully created; `false` if the named file already exists
  Throws:
    `IOException` - If an I/O error occurred

### delete

    public boolean delete()

  Deletes the file or directory denoted by this abstract pathname. If this pathname denotes a directory, then the directory must be empty in order to be deleted.
  Returns:
    `true` if and only if the file or directory is successfully deleted; `false` otherwise

### list

    public String[] list()

  Returns an array of strings naming the files and directories in the directory denoted by this abstract pathname.

  If this abstract pathname does not denote a directory, then this method returns `null`. Otherwise an array of strings is returned, one for each file or directory in the directory. Names denoting the directory itself and the directory's parent directory are not included in the result. Each string is a file name rather than a complete path.

  There is no guarantee that the name strings in the resulting array will appear in any specific order; they are not, in particular, guaranteed to appear in alphabetical order.

  Returns:
    An array of strings naming the files and directories in the directory denoted by this abstract pathname. The array will be empty if the directory is empty. Returns `null` if this abstract pathname does not denote a directory, or if an I/O error occurs.

### listFiles

    public OWFile[] listFiles()

  Returns an array of abstract pathnames denoting the files in the directory denoted by this abstract pathname.

  If this abstract pathname does not denote a directory, then this method returns `null`. Otherwise an array of `OWFile` objects is returned, one for each file or directory in the directory. Pathnames denoting the directory itself and the directory's parent directory are not included in the result. Each resulting abstract pathname is constructed from this abstract pathname using the ``OWFile(OWFile, String)`` constructor. Therefore if this pathname is absolute then each resulting pathname is absolute; if this pathname is relative then each resulting pathname will be relative to the same directory.

  There is no guarantee that the name strings in the resulting array will appear in any specific order; they are not, in particular, guaranteed to appear in alphabetical order.

  Returns:
    An array of abstract pathnames denoting the files and directories in the directory denoted by this abstract pathname. The array will be empty if the directory is empty. Returns `null` if this abstract pathname does not denote a directory, or if an I/O error occurs.

### mkdir

    public boolean mkdir()

  Creates the directory named by this abstract pathname.
  Returns:
    `true` if and only if the directory was created; `false` otherwise

### mkdirs

    public boolean mkdirs()

  Creates the directory named by this abstract pathname, including any necessary but nonexistent parent directories. Note that if this operation fails it may have succeeded in creating some of the necessary parent directories.
  Returns:
    `true` if and only if the directory was created, along with all necessary parent directories; `false` otherwise

### renameTo

    public boolean renameTo(OWFile dest)

  Renames the file denoted by this abstract pathname.
  Parameters:
    `dest` - The new abstract pathname for the named file
  Returns:
    `true` if and only if the renaming succeeded; `false` otherwise
  Throws:
    `NullPointerException` - If parameter `dest` is `null`

### setLastModified

    public boolean setLastModified(long time)

  Sets the last-modified time of the file or directory named by this abstract pathname.

  All platforms support file-modification times to the nearest second, but some provide more precision. The argument will be truncated to fit the supported precision. If the operation succeeds and no intervening operations on the file take place, then the next invocation of the ``lastModified()`` method will return the (possibly truncated) `time` argument that was passed to this method.

  Parameters:
    `time` - The new last-modified time, measured in milliseconds since the epoch (00:00:00 GMT, January 1, 1970)
  Returns:
    `true` if and only if the operation succeeded; `false` otherwise
  Throws:
    `IllegalArgumentException` - If the argument is negative

### setReadOnly

    public boolean setReadOnly()

  Marks the file or directory named by this abstract pathname so that only read operations are allowed. After invoking this method the file or directory is guaranteed not to change until it is either deleted or marked to allow write access. Whether or not a read-only file or directory may be deleted depends upon the underlying system.
  Returns:
    `true` if and only if the operation succeeded; `false` otherwise

### listRoots

    public static OWFile[] listRoots(OneWireContainer owc)

  List the available filesystem roots.

  A particular Java platform may support zero or more hierarchically-organized Filesystems. Each Filesystem has a `root` directory from which all other files in that file system can be reached. Windows platforms, for example, have a root directory for each active drive; UNIX platforms have a single root directory, namely `"/"`. The set of available filesystem roots is affected by various system-level operations such the insertion or ejection of removable media and the disconnecting or unmounting of physical or virtual disk drives.

  This method returns an array of `OWFile` objects that denote the root directories of the available filesystem roots. It is guaranteed that the canonical pathname of any file physically present on the local machine will begin with one of the roots returned by this method.

  The canonical pathname of a file that resides on some other machine and is accessed via a remote-filesystem protocol such as SMB or NFS may or may not begin with one of the roots returned by this method. If the pathname of a remote file is syntactically indistinguishable from the pathname of a local file then it will begin with one of the roots returned by this method. Thus, for example, `OWFile` objects denoting the root directories of the mapped network drives of a Windows platform will be returned by this method, while `OWFile` objects containing UNC pathnames will not be returned by this method.

  Parameters:
    `owc` - OneWireContainer that this Filesystem resides on
  Returns:
    An array of `OWFile` objects denoting the available filesystem roots, or `null` if the set of roots could not be determined. The array will be empty if there are no filesystem roots.

### compareTo

    public int compareTo(OWFile pathname)

  Compares two abstract pathnames lexicographically. The ordering defined by this method depends upon the underlying system. On UNIX systems, alphabetic case is significant in comparing pathnames; on Win32 systems it is not.
  Parameters:
    `pathname` - The abstract pathname to be compared to this abstract pathname
  Returns:
    Zero if the argument is equal to this abstract pathname, a value less than zero if this abstract pathname is lexicographically less than the argument, or a value greater than zero if this abstract pathname is lexicographically - greater than the argument

### compareTo

    public int compareTo(Object o)

  Compares this abstract pathname to another object. If the other object is an abstract pathname, then this function behaves like ``compareTo(OWFile)``. Otherwise, it throws a `ClassCastException`, since abstract pathnames can only be compared to abstract pathnames.
  Parameters:
    `o` - The `Object` to be compared to this abstract pathname
  Returns:
    If the argument is an abstract pathname, returns zero if the argument is equal to this abstract pathname, a value less than zero if this abstract pathname is lexicographically less than the argument, or a value greater than zero if this abstract pathname is lexicographically greater than the argument
  Throws:
    ``ClassCastException`` - if the argument is not an abstract pathname
  See Also:
    `Comparable`

### equals

    public boolean equals(Object obj)

  Tests this abstract pathname for equality with the given object. Returns `true` if and only if the argument is not `null` and is an abstract pathname that denotes the same file or directory as this abstract pathname. Whether or not two abstract pathnames are equal depends upon the underlying system. On UNIX systems, alphabetic case is significant in comparing pathnames; on Win32 systems it is not.
  Overrides:
    `equals` in class `Object`
  Parameters:
    `obj` - The object to be compared with this abstract pathname
  Returns:
    `true` if and only if the objects are the same; `false` otherwise

### hashCode

    public int hashCode()

  Computes a hash code for this abstract pathname. Because equality of abstract pathnames is inherently system-dependent, so is the computation of their hash codes. On UNIX systems, the hash code of an abstract pathname is equal to the exclusive or of its pathname string and the decimal value `1234321`. On Win32 systems, the hash code is equal to the exclusive or of its pathname string, convered to lower case, and the decimal value `1234321`.
  Overrides:
    `hashCode` in class `Object`
  Returns:
    A hash code for this abstract pathname

### toString

    public String toString()

  Returns the pathname string of this abstract pathname. This is just the string returned by the ``getPath()`` method.
  Overrides:
    `toString` in class `Object`
  Returns:
    The string form of this abstract pathname

### getFD

    public OWFileDescriptor getFD()
                           throws IOException

  Returns the `OWFileDescriptor` object that represents the connection to the actual file in the Filesystem being used by this `OWFileInputStream`.
  Returns:
    the file descriptor object associated with this File.
  Throws:
    `IOException` - if an I/O error occurs.
  See Also:
    `OWFileDescriptor`

### getOneWireContainer

    public OneWireContainer getOneWireContainer()

  Gets the OneWireContainer that this File resides on. This is where the 'filesystem' resides. If this Filesystem spans multiple devices then this method returns the 'MASTER' device.
  Returns:
    the OneWireContainer for this Filesystem

### getOneWireContainers

    public OneWireContainer[] getOneWireContainers()

  Gets the OneWireContainer(s) that this File resides on. This is where the 'filesystem' resides. The first device is the 'MASTER' device and the other devices are 'SATELLITE' devices.
  Returns:
    the OneWireContainer(s) for this Filesystem

### format

    public void format()
                throws IOException

  Format the Filesystem on the 1-Wire device provided in the constructor. This operation is required before any file IO is possible.

  WARNING this will remove any files/directories.

  Throws:
    `IOException` - if an I/O error occurs.

### getFreeMemory

    public int getFreeMemory()
                      throws IOException

  Gets the number of bytes available on this device for file and directory information.
  Returns:
    number of free bytes in the Filesystem
  Throws:
    `IOException` - if an I/O error occurs

### close

    public void close()
               throws IOException

  Closes this file and releases any system resources associated with this stream. This file may no longer be used after this operation.
  Throws:
    `IOException` - if an I/O error occurs.

### getPageList

    public int[] getPageList()
                      throws IOException

  Get's an array of integers that represents the page list of the file or directory represented by this OWFile.
  Returns:
    node page list file or directory
  Throws:
    `IOException` - if an I/O error occurs.

### getMemoryBankForPage

    public PagedMemoryBank getMemoryBankForPage(int page)

  Get's the memory bank object for the specified page. This is significant if the Filesystem spans memory banks on the same or different devices.
  Returns:
    PagedMemoryBank for the specified page

### getLocalPage

    public int getLocalPage(int page)

  Get's the local page number on the memory bank object for the specified page. This is significant if the Filesystem spans memory banks on the same or different devices.
  Returns:
    local page for the specified Filesystem page (memory bank specific)

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD